<template>
	<div>
		<transition name="fade">
			<div class="tutorial-terminal" v-if="current_tutorial.active" v-on:click.self="closeTutorial">
				<div class="main-column" v-on:click.self="closeTutorial">
					<div class="terminal center">
						<div class="bar flex space" :class="['light'+theme_color+'-bkg']">
							<div class="title">
								<span>v.exe</span>
								<span> - {{tutorial_step}}</span>
							</div>
							
							<div class="close" v-on:click="closeTutorial">
								<span></span>
								<span></span>
							</div>
						</div>
					
						<div class="wrapper" :class="[theme_color+'-gradient']" v-on:click="finishLine" @contextmenu="finishLine">
							<div class="screen" ref="screen">
								<div class="line" v-for="line in lines">
									<span v-html="line"></span>
								</div>
							</div>
						</div>
					</div>
				</div>	
			</div>
		</transition>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';
	
	export default {
		props : ['tutorial_step', 'color'],
		data: function () {
			return{ 
				lines: [],
				current_line: 0,
				finish_line: false,
				lines_to_write: [],
				text_to_write: '',
				patterns : []
			}
		},
		computed: {
			theme_color(){
				return this.color ? this.color : 'azure';
			}
		},
		methods: {
			nextLine(){
				if(this.lines_to_write.length > 0){
					this.text_to_write = this.lines_to_write.shift();
					
					var regExp = /\{([^)]+)\}/g;
					var matches = this.text_to_write.match(regExp);
					
					if(matches !== null){
						for(var i = 0; i < matches.length; i++) {
							var pattern = matches[i].substring(1, matches[i].length - 1);
							pattern = pattern.split('-');
							var replace = '';
							
							
							switch(pattern[0]){
								case 'image':
									var url = browser.runtime.getURL('/images/'+pattern[1]);
									replace = '<img class="'+pattern[1].replace('.', '')+'" src="'+url+'">';
								break;
								case 'profile_link':
									var url = browser.extension.getURL('/profile/profile.html#vairus');
									replace = '<a target="_blank" href="'+url+'">'+pattern[1]+'</a>';
								break;
								case 'network_link':
									var url = browser.extension.getURL('/profile/profile.html#network');
									replace = '<a target="_blank" href="'+url+'">'+pattern[1]+'</a>';
								break;
								case 'analyzer_link':
									var url = browser.extension.getURL('/profile/profile.html#analyzer');
									replace = '<a target="_blank" href="'+url+'">'+pattern[1]+'</a>';
								break;
							}
							this.patterns.push(replace);
							this.text_to_write = this.text_to_write.replace(matches[i], '@');
						}
					}
					this.lines.push('');
					this.addCharacter();
				}
			},
			addCharacter(){
				if(!this.$refs.screen) return
				
				let screen = this.$refs.screen;
				
				if(this.text_to_write[0] == '@'){
					let pattern = this.patterns.shift();
					this.lines[this.current_line]+=pattern;
					this.text_to_write = this.text_to_write.substring(1);
				}else{
					if(!this.finish_line){
						//Print the next character
						this.lines[this.current_line] += this.text_to_write[0];
						this.text_to_write = this.text_to_write.substring(1);
						this.lines.splice();
					}else{
						//Print the rest of the line
						this.lines[this.current_line] += this.text_to_write;
						this.text_to_write = '';
						this.lines.splice();
						this.finish_line = false;
					}
				}
				
				this.$nextTick(() => screen.scrollTop = screen.scrollHeight);
				
				if(this.text_to_write.length > 0){
					setTimeout(this.addCharacter, 20);
				}else{
					this.current_line++;
					setTimeout(this.nextLine, 1000);
				}
			},
			finishLine(){
				if(this.text_to_write != '')
					this.finish_line = true;
			}
		},
		watch: { 
			tutorial_step: function(step) {
				this.lines_to_write.splice(0);
				this.lines.splice(0);
				this.patterns.splice(0);
				this.text_to_write = '';
				this.finish_line = false;
				this.current_line = 0;
					
				if(step != ''){
					let text =  this.getLocale('tutorial_'+step+'_text')
					
					if(this.current_tutorial.fast){
						var newlines = text.split('\n');
						for(var i =0; i<newlines.length; i++){
							this.lines.push(newlines[i]);
						}
					}else{
						var newlines = text.split('\n');
						for(var i =0; i<newlines.length; i++){
							this.lines_to_write.push(newlines[i]);
						}
						setTimeout(() => this.nextLine(), 1000);
					}
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
	}
</script>


<style lang="scss">
	@import "../styles/variables";
	
	.tutorial-terminal{
		position: fixed;
		top: 0;
		left: 0;
		bottom: 0;
		right: 0;
		z-index: 2147483647;
		background-color: rgba(0,0,0,0.8);
		
		.main-column{
			height: 100%;
		}
		
		.terminal{
			position: absolute;
			left: 50%;
			top: 50%;
			width: 700px;
			height: 400px;
			max-width: 95vw;
			max-height: 95vh;
			transform: translate(-50%,-50%);
			overflow: hidden;
			font: 1.2em Inconsolata, monospace;
			
			.bar{
				position: absolute;
				top: 0;
				left: 0;
				width: 100%;
				height: 25px;
				align-items: center;
				
				.title{
					margin-left: 3px;
					color: black;
				}
				
				.close{
					position: relative;
					width: 20px;
					height: 20px;
					margin-right: 3px;
					cursor: pointer;
					
					span{
						position: absolute;
						width: 18px;
						height: 1px;
						background-color: black;
						left: 1px;
						top: 9px;
						transform: rotate(-45deg);
						
						&:first-child{
							transform: rotate(45deg);
						}
					}
				}
			}
			
			.wrapper{
				position: absolute;
				left: 0;
				top: 25px;
				right: 0;
				bottom: 0;
				padding: 25px;
			
				&:after {
					content: "";
					position: absolute;
					top: 0;
					left: 0;
					width: 100vw;
					height: 100vh;
					background: repeating-linear-gradient(0deg, rgba(0, 0, 0, 0.2), rgba(0, 0, 0, 0.2) 1px, transparent 6px, transparent 2px);
					pointer-events: none;
				}
				
				&::selection {
					background: #0080FF;
					text-shadow: none;
				}
				.screen{
					height: 100%;
					padding-right: 25px;
					overflow-y: auto;
					overflow-x: hidden;
					color: $lightestazure;
					
					a{
						color: $lightestazure;
					}
					
					.line{    
						margin-bottom: 15px;
						
						&:last-child span:after{
							content : '';
							margin-left: 2px;
							border-right: 1px solid $lightestazure;
							animation: blink-animation 1s steps(5, start) infinite;
						}
					}
					
					img{
						position: relative;
						z-index: 20;
						max-width: 100px;
						width: 100px;
						
						&.analizzapng,
						&.analyzepng{
							width: 250px;
							max-width: 205px;
						}
					}
				}
			}
		}
	}
	
	@media screen and (max-width: 600px) {
		.tutorial-terminal .terminal .wrapper{
			padding: 10px;
			
			.screen{
				padding-right: 10px;
			}
		}
	}
	
	@keyframes blink-animation { 
		50% { visibility: hidden; }
	}
	@-webkit-keyframes blink-animation {
		50% { visibility: hidden; }
	}
</style>

